#include "stdafx.h"
#include "Contracts.h"
#include "nef.h"
#include <sstream>
#include "ExoticContracts.h"

class ExoticSeparator
	: public ISeparator
{
public:
	ExoticSeparator()
	{
		std::stringstream ss;
		ss << COUNTER++;

		_middle = ss.str();
	}
	
	virtual std::string GetSeparator() const
	{
		return std::string(" <") + _middle + "[>_<]" + _middle + "> ";
	}

private:
	static size_t COUNTER;

	std::string _middle;
};

size_t ExoticSeparator::COUNTER = 0;

nef::nef_export<ExoticSeparator, ISeparator, EXOTIC_CONTRACT, nef::non_shared> sep_Export;